macroScript meshCleaner
category:"KFScripts" 
toolTip:"Mesh Cleaner 1.01" 
buttonText:"Mesh Cleaner 1.01"
---------------------------
---v1.01 of meshCleaner---
--Written by Kiel Figgins--
------www.3dfiggins.com----
---------------------------
--This script is an automated approach to cleaning the xform and general disruption out of meshes
--------------------
--Version History
--------------------
--1.01 (07-16-2007) - Verified that 'Renderable' was checked
--1.00 (07-09-2007) - Original Script
--------------------
--Coming Soon
--------------------


(--Start Script
try(destroydialog meshCleaner)catch()


rollout meshCleaner "Mesh Cleaner     v1.01"
(
label lbl01 "1. Select Mesh(es)"
button btnClean "2. Clean Up"

on btnClean pressed do (

--Verify one selected
numSel = selection.count

if numSel == 0 then
	(print "Please Select an Object") else()

if numSel == 1 then
	(
			curObj = $
			objType = classof curObj as string
			if objType == "Editable_Poly" or objType == "Editable_Mesh" then
			(
				--Define User object
				userObj = $
				namer = $.name

				-----------------------------------------------------
				--Zeroing and Cleaning Mesh
				-----------------------------------------------------
				Box lengthsegs:1 widthsegs:1 heightsegs:1 length:1 width:1 height:1 mapCoords:on pos:[0,0,0] name:"BoxZeroed" isSelected:on
				macros.run "Modifier Stack" "Convert_to_Poly"
				
				--Switch Panel mode
				setCommandPanelTaskMode #modify
				$.EditablePoly.attach userObj $BoxZeroed
				subobjectLevel = 5
				$.EditablePoly.SetSelection #Face #{1..6}
				$.EditablePoly.delete #Face
				$BoxZeroed.wirecolor = color 0 0 0
				
				subobjectLevel = 0
				
				--setTransformLockFlags 
				--$BoxZeroed #{1,2,3,4,5,6,7,8,9}
				
				--Turn Show Frozen Off
				$BoxZeroed.showFrozenInGray = off
				$BoxZeroed.backFaceCull = off

				--Render settings
				--$BoxZeroed.visibility = 1
				$BoxZeroed.renderable = true
				
				--name object based off selection name
				$BoxZeroed.name = namer

				clearSelection()
				print "Mesh Clean"
			) 
			else (print "ERROR: Not a known mesh type")
	)
	else ()


if numSel > 1 then
	(
			curObjArray = $ as array
			curObjCount = curObjArray.count

			for i = 1 to curObjCount do
			(
				select curObjArray [i]
				curObj = $
							objType = classof curObj as string
							if objType == "Editable_Poly" or objType == "Editable_Mesh" then
							(
								--Define User object
								userObj = $
								namer = $.name
				
								
								-----------------------------------------------------
								--Zeroing and Cleaning Mesh
								-----------------------------------------------------
								Box lengthsegs:1 widthsegs:1 heightsegs:1 length:1 width:1 height:1 mapCoords:on pos:[0,0,0] name:"BoxZeroed" isSelected:on
								macros.run "Modifier Stack" "Convert_to_Poly"
								
								--Switch Panel mode
								setCommandPanelTaskMode #modify
								$.EditablePoly.attach userObj $BoxZeroed
								subobjectLevel = 5
								$.EditablePoly.SetSelection #Face #{1..6}
								$.EditablePoly.delete #Face
								$BoxZeroed.wirecolor = color 0 0 0
								
								subobjectLevel = 0
								
								--setTransformLockFlags 
								--$BoxZeroed #{1,2,3,4,5,6,7,8,9}
								
								--Turn Show Frozen Off
								$BoxZeroed.showFrozenInGray = off
								$BoxZeroed.backFaceCull = off
								
								--Render settings
								--$BoxZeroed.visibility = 1
								$BoxZeroed.renderable = true
				
								--name object based off selection name
								$BoxZeroed.name = namer
								
								clearSelection()
								print "Mesh Clean"
							) 
							else (print "ERROR: Not a known mesh type")
				)--End of For loop
	)
	else ()
)--End of button

)--End of rollout
createDialog meshCleaner width:140 height:50 pos:[1100,80] \
style:#(#style_border, #style_titlebar, #style_sysmenu, #style_minimizebox)
try(cui.RegisterDialogBar meshCleaner maxsize:[140,50]) catch()

)--End Script